#include <stdio.h>
#include <stdlib.h>
#include "list.h"

// PRIMITIVE

// Restituisce la lista vuota
list emptyList(void) { 
	return NULL; 
} 

// Restituisce vero se la lista data  vuota,
// falso altrimenti
Boolean empty(list l) {
	if (l==NULL) return TRUE; 
	else return FALSE; 
}

// Restituisce primo elemento della lista data
Element head(list l) {
	if (empty(l)) abort();
	else return  l->value; 
}

// Restituisce la coda della lista data
list tail(list l) {
	if (empty(l)) abort();
	else return l->next; 
}

// Costruisce una nuova lista, aggiungendo l'elemento
// fornito in testa alla lista data
list cons(Element e, list l) { 
	list t;
	t = (list) malloc(sizeof(node));
	t->value=e; 
	t->next=l; 
	return t; 
}

// NON PRIMITIVE

// Stampa lista
void showList(list l) { 
	printf("[");
	while (!empty(l)) {  // Finch non  vuota..
		printf("%d", head(l));
		l = tail(l);
		if (!empty(l)) printf(", "); 
	} 
	printf("]\n");
}

// Restituisce una lista che  concatenamento delle due liste date
list append(list l1, list l2) { 
	if (empty(l1)) return l2;
	else return cons(head(l1), append(tail(l1),l2));
}

// Restituisce una lista che  l'inverso della lista data
list reverse(list l) {
	if (empty(l)) return emptyList(); 
	else return append(reverse(tail(l)), cons(head(l), emptyList()));
}

// DEALLOCAZIONE
void dealloc(list l){
    list temp;          // Create una lista temporanea come appoggio
    while (!empty(l)) { 
        temp = l;
        l = tail(l);
        free(temp);     // Liberiamo ogni elemento della lista uno
    }                   // alla volta
}